//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 512
#property strict

enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
};

input int       StartRsi  = 8;           // First RSI period
input int       NoRsi     = 10;          // Number of RSIs
input int       RsiStep   = 2;           // RSI periods increment
input enPrices  Price     = pr_close;    // Price to use
input int       LineWidth = 0;           // Lines width
input int       LineStyle = STYLE_SOLID; // Lines styles

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int periods[] = {};
struct simpleBuff { double buffer[]; };
       simpleBuff aBuffers[512];
int steps;

//
//
//
//
//

int OnInit()
{
   steps = MathMax(MathMin(NoRsi,512),1); ArrayResize(periods,steps);
      int i;
       for (i=0;i<steps; i++)
       {
         periods[i] = StartRsi+i*RsiStep;
            SetIndexBuffer(i,aBuffers[i].buffer,INDICATOR_DATA);
            SetIndexStyle(i,DRAW_LINE,LineStyle,LineWidth,clrRed);
            SetIndexLabel(i,"rsi "+(string)(i+1)+" : "+(string)periods[i]);
       }
       for( ; i<512; i++) SetIndexLabel(i,NULL);
   IndicatorShortName("Multiple "+(string)steps+" RSI");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime& time[],
                const double& open[],
                const double& high[],
                const double& low[],
                const double& close[],
                const long& tick_volume[],
                const long& volume[],
                const int& spread[])
{
   for (int k=0; k<steps; k++)
      for (int i=(int)MathMax(rates_total-prev_calculated-1,2); i>=0; i--)
                  aBuffers[k].buffer[i] = iRSI(NULL,0,periods[k],(int)Price,i);
   return(rates_total);
}